'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports["default"] = wrapWithFilter;

var _react = require('react');

var _shallowEqual = require('../utils/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _getDisplayName = require('../utils/getDisplayName');

var _getDisplayName2 = _interopRequireDefault(_getDisplayName);

var _setSome = require('../utils/setSome');

var _setSome2 = _interopRequireDefault(_setSome);

var _pickSet = require('../utils/pickSet');

var _pickSet2 = _interopRequireDefault(_pickSet);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function wrapWithFilter(WrappedComponent) {
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var connectDisplayName = 'Filter(' + (0, _getDisplayName2["default"])(WrappedComponent) + ')';
  var _options$pure = options.pure;
  var pure = _options$pure === undefined ? true : _options$pure;
  var _options$withRef = options.withRef;
  var withRef = _options$withRef === undefined ? false : _options$withRef;

  var Filter = function (_Component) {
    _inherits(Filter, _Component);

    function Filter(props, context) {
      _classCallCheck(this, Filter);

      (0, _invariant2["default"])(context.getBlackboxFacsimiles, 'Could not find "getBlackboxFacsimiles" in the ' + ('context of "' + connectDisplayName + '". Please make sure the react-redux-blackbox ') + 'Provider component is at the root of the application');

      var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

      var blackbox = props.blackbox;

      var otherProps = _objectWithoutProperties(props, ['blackbox']);

      (0, _invariant2["default"])(props.blackbox, 'Could not find "blackbox" in the ' + ('props of "' + connectDisplayName + '". '));
      _this.blackbox = blackbox;
      _this.otherProps = otherProps;
      _this.connectIds = new Set();
      return _this;
    }

    Filter.prototype.addConnectIds = function addConnectIds(ids) {
      var _this2 = this;

      ids.forEach(function (id) {
        _this2.connectIds.add(id);
      });
      this.context.addConnectIds && this.context.addConnectIds(this.connectIds);
    };

    Filter.prototype.removeConnectIds = function removeConnectIds(ids) {
      var _this3 = this;

      ids.forEach(function (id) {
        _this3.connectIds["delete"](id);
      });
      this.context.removeConnectIds && this.context.removeConnectIds(ids);
    };

    Filter.prototype.getChildContext = function getChildContext() {
      return {
        addConnectIds: this.addConnectIds.bind(this),
        removeConnectIds: this.removeConnectIds.bind(this)
      };
    };

    Filter.prototype.otherProps_changed = function otherProps_changed(otherProps) {
      if ((0, _shallowEqual2["default"])(otherProps, this.otherProps)) {
        return false;
      }
      this.otherProps = otherProps;
      return true;
    };

    Filter.prototype.filteredBlackbox_changed = function filteredBlackbox_changed(blackbox) {
      var _this4 = this;

      var change = (0, _setSome2["default"])(this.connectIds, function (id) {
        return !_this4.context.getBlackboxFacsimiles(id);
      });
      if (change) {
        this.blackbox = (0, _pickSet2["default"])(blackbox, this.connectIds);
      }
      return change;
    };

    Filter.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
      var blackbox = nextProps.blackbox;

      var otherProps = _objectWithoutProperties(nextProps, ['blackbox']);

      var blackboxChanged = this.filteredBlackbox_changed(blackbox);
      var otherPropsChanged = this.otherProps_changed(otherProps);
      return !pure || blackboxChanged || otherPropsChanged;
    };

    Filter.prototype.componentWillUnmount = function componentWillUnmount() {
      this.context.removeConnectIds(this.connectIds);
      this.clearCache();
    };

    Filter.prototype.clearCache = function clearCache() {
      this.blackbox = null;
      this.otherProps = null;
      this.connectIds = null;
    };

    Filter.prototype.getMergedProps = function getMergedProps() {
      var blackbox = this.blackbox;
      var otherProps = this.otherProps;

      return _extends({ blackbox: blackbox }, otherProps);
    };

    Filter.prototype.render = function render() {
      if (withRef) {
        return (0, _react.createElement)(WrappedComponent, _extends({}, this.getMergedProps(), { ref: 'wrappedInstance' }));
      }
      return (0, _react.createElement)(WrappedComponent, this.getMergedProps());
    };

    return Filter;
  }(_react.Component);

  Filter.displayName = connectDisplayName;
  Filter.WrappedComponent = WrappedComponent;
  Filter.contextTypes = {
    addConnectIds: _react.PropTypes.func,
    removeConnectIds: _react.PropTypes.func,
    getBlackboxFacsimiles: _react.PropTypes.func.isRequired
  };
  Filter.propTypes = {
    blackbox: _react.PropTypes.object.isRequired
  };
  Filter.childContextTypes = {
    addConnectIds: _react.PropTypes.func,
    removeConnectIds: _react.PropTypes.func
  };

  return (0, _hoistNonReactStatics2["default"])(Filter, WrappedComponent);
}